LightOJ 1017 Brush (III) (DP)

Brush (III)
Time Limit:2000MS Memory Limit:32768KB 64bit IO Format:%lld & %llu
Submit

Status
Description
Samir returned home from the contest and got angry after seeing his room dusty. Who likes to see a dusty room after a brain storming programming contest? After checking a bit he found a brush in his room which has width w. Dusts are defined as 2D points. And since they are scattered everywhere, Samir is a bit confused what to do. He asked Samee and found his idea. So, he attached a rope with the brush such that it can be moved horizontally (in X axis) with the help of the rope but in straight line. He places it anywhere and moves it. For example, the y co-ordinate of the bottom part of the brush is 2 and its width is 3, so the y coordinate of the upper side of the brush will be 5. And if the brush is moved, all dusts whose y co-ordinates are between 2 and 5 (inclusive) will be cleaned. After cleaning all the dusts in that part, Samir places the brush in another place and uses the same procedure. He defined a move as placing the brush in a place and cleaning all the dusts in the horizontal zone of the brush.
You can assume that the rope is sufficiently large. Since Samir is too lazy, he doesn’t want to clean all the room. Instead of doing it he thought that he would use at most k moves. Now he wants to find the maximum number of dust units he can clean using at most k moves. Please help him.
Input
Input starts with an integer T (≤ 100), denoting the number of test cases.
Each case starts with a blank line. The next line contains three integers N (1 ≤ N ≤ 100), w (1 ≤ w ≤ 10000) and k (1 ≤ k ≤ 100). N means that there are N dust points. Each of the next N lines contains two integers: xi yi denoting the coordinates of the dusts. You can assume that (-109 ≤ xi, yi ≤ 109) and all points are distinct.
Output
For each case print the case number and the maximum number of dusts Samir can clean using at most k moves.
Sample Input
2

3 2 1
0 0
20 2
30 2

3 1 1
0 0
20 2
30 2
Sample Output
Case 1: 3
Case 2: 2

就普通DP。。轉移方程看代碼

#include "cstring"
#include "cstdio"
#include "string.h"
#include "iostream"
#include "algorithm"
using namespace std;
int main()
{
    int t;
    scanf("%d",&t);
    int cas=1;
    while(t--)
    {
        int n,w,k;
        scanf("%d%d%d",&n,&w,&k);
        int dp[105][105];
        memset(dp,0,sizeof(dp));
        int a[105];
        int temp;
        for(int i=0;i<n;i++)
            scanf("%d%d",&temp,&a[i]);
        sort(a,a+n);
        int ans=0;
        for(int i=0;i<n;i++)
        {
            for(int j=i;j<n;j++)
            {
                if(a[j]-a[i]<=w)
                    dp[i][1]++;
                else
                    break;
            }
        }
        for(int i=0;i<n;i++)
        {
            for(int nowk=2;nowk<=k;nowk++)
            {
                for(int j=0;j<i;j++)
                {
                    if(a[i]-a[j]>w)
                        dp[i][nowk]=max(dp[i][nowk],dp[j][nowk-1]+dp[i][1]);
                    else
                        break;
                }
            }
        }
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<=k;j++)
            {
                ans=max(ans,dp[i][j]);
            }
        }
        printf("Case %d: %d\n",cas++,ans);
    }
    return 0;
}
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章